dart/urls.py
# Copyright 2017 Lockheed Martin Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

from django.conf.urls import include, url
from django.contrib import admin
from django.views.generic import RedirectView
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
import missions.views
from django.contrib.auth.decorators import login_required
from django.contrib.auth.views import logout, login
from django.views.static import serve
from django.conf import settings

urlpatterns = [
    url(r'^missions/', include('missions.urls')),

    url(r'^$', RedirectView.as_view(url='/missions/', permanent=False)),

    url(r'^admin/', include(admin.site.urls)),

    url(r'^accounts/logout/$', logout, name='logout'),
    url(r'^accounts/login/$', login, {'template_name': 'login.html'}, name='login'),
    url(r'^accounts/$', RedirectView.as_view(url='/', permanent=False)),
    url(r'^accounts/profile/$', RedirectView.as_view(url='/', permanent=False)),

    url(r'^settings/$',
        login_required(missions.views.UpdateDynamicSettingsView.as_view()), name='update-settings'),
    url(r'^settings/business-areas/$',
        login_required(missions.views.BusinessAreaListView.as_view()), name='list-business-areas'),
    url(r'^settings/update-business-area(?:/(?P<pk>\d+))?/$',
        login_required(missions.views.business_area_handler), name='update-business-area'),
    url(r'^settings/classifications/$',
        login_required(missions.views.ClassificationListView.as_view()), name='list-classifications'),
    url(r'^settings/update-classification(?:/(?P<pk>\d+))?/$',
        login_required(missions.views.classification_handler), name='update-classification'),
    url(r'^settings/colors/$',
        login_required(missions.views.ColorListView.as_view()), name='list-colors'),
    url(r'^settings/update-color(?:/(?P<pk>\d+))?/$',
        login_required(missions.views.color_handler), name='update-color'),
    url(r'^settings/create-account/$',
        missions.views.CreateAccountView.as_view(), name='create-account'),

    url(r'^login-interstitial/$',
        login_required(missions.views.LoginInterstitialView.as_view()), name='login-interstitial'),

    url(r'^about/$',
        login_required(missions.views.AboutTemplateView.as_view()), name='about'),

    url(r'^hosts/(?P<host_id>\d+)/$',
        login_required(missions.views.mission_host_handler), name='host-detail'),

    url(r'^data/(?P<supportingdata>\d+)/$',
        login_required(missions.views.DownloadSupportingDataView.as_view()), name='data-view'),
    url(r'^data/(?P<path>.*)$',
        serve,{'document_root': settings.MEDIA_ROOT, 'show_indexes': False}),
]

urlpatterns += staticfiles_urlpatterns()

missions/urls.py
# -*- coding: utf-8 -*-

# Copyright 2017 Lockheed Martin Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

from django.conf.urls import url
import missions.views
from django.contrib.auth.decorators import login_required

urlpatterns = [
    url(r'^$',
        login_required(missions.views.ListMissionView.as_view()), name='missions-list'),
    url(r'^new/$',
        login_required(missions.views.CreateMissionView.as_view()), name='missions-new'),
    url(r'^(?P<pk>\d+)/$',
        login_required(missions.views.EditMissionView.as_view()), name='missions-edit',),
    url(r'^(?P<pk>\d+)/delete/$',
        login_required(missions.views.DeleteMissionView.as_view()), name='missions-delete',),
    url(r'^(?P<mission>\d+)/report/$',
        login_required(missions.views.ReportMissionView.as_view()), name='mission-report',),
    url(r'^(?P<mission>\d+)/attachments/$',
        login_required(missions.views.ReportAttachmentsMissionView.as_view()), name='mission-attachments', ),
    url(r'^(?P<mission>\d+)/stats/$',
        login_required(missions.views.MissionStatsView.as_view()), name='mission-stats',),
    url(r'^(?P<mission_id>\d+)/hosts/$',
        login_required(missions.views.EditMissionHostsView.as_view()), name='mission-hosts'),


    url(r'^(?P<mission>\d+)/tests/$',
        login_required(missions.views.ListMissionTestsView.as_view()), name='mission-tests'),
    url(r'^(?P<mission>\d+)/tests/new/$',
        login_required(missions.views.CreateMissionTestView.as_view()), name='mission-test-new'),
    url(r'^(?P<mission>\d+)/tests/(?P<pk>\d+)/$',
        login_required(missions.views.EditMissionTestView.as_view()), name='mission-test-view'),
    url(r'^(?P<mission>\d+)/tests/(?P<pk>\d+)/edit$',
        login_required(missions.views.EditMissionTestView.as_view()), name='mission-test-edit'),
    url(r'^(?P<mission>\d+)/tests/(?P<pk>\d+)/delete/$',
        login_required(missions.views.DeleteMissionTestView.as_view()), name='mission-test-delete'),
    url(r'^(?P<mission>\d+)/tests/(?P<pk>\d+)/clone/$',
        login_required(missions.views.CloneMissionTestView.as_view()), name='mission-tests-clone'),
    url(r'^(?P<mission>\d+)/tests/reorder/$',
        login_required(missions.views.OrderMissionTestsView.as_view()), name='mission-tests-reorder'),
    url(r'^(?P<mission_id>\d+)/tests/(?P<test_id>\d+)/hosts',
        login_required(missions.views.test_host_handler), name='test-hosts'),

    url(r'^(?P<mission>\d+)/tests/(?P<test_detail>\d+)/data/$',
        login_required(missions.views.ListMissionTestsSupportingDataView.as_view()), name='test-data-list'),
    url(r'^(?P<mission>\d+)/tests/(?P<test_detail>\d+)/data/new/$',
        login_required(missions.views.CreateMissionTestsSupportingDataView.as_view()), name='test-data-new'),
    url(r'^(?P<mission>\d+)/tests/(?P<test_detail>\d+)/data/(?P<pk>\d+)/$',
        login_required(missions.views.EditMissionTestsSupportingDataView.as_view()), name='test-data-edit'),
    url(r'^(?P<mission>\d+)/tests/(?P<test_detail>\d+)/data/(?P<pk>\d+)/delete/$',
        login_required(missions.views.DeleteMissionTestsSupportingDataView.as_view()), name='test-data-delete'),
    url(r'^(?P<mission>\d+)/tests/(?P<test_detail>\d+)/data/reorder/$',
        login_required(missions.views.OrderMissionTestsSupportingDataView.as_view()), name='test-data-reorder'),

]

missions/models.py
# -*- coding: utf-8 -*-

# Copyright 2017 Lockheed Martin Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

import os

from django.core.cache import cache
from django.db import models
from django.db.models.signals import post_delete
from django.dispatch.dispatcher import receiver
from django.utils import timezone
from django.core.urlresolvers import reverse_lazy
from django.conf import settings

from extras.helpers.formatters import join_as_compacted_paragraphs
from extras.validators import validate_host_format_string


"""
Defaults
Python 2 can't serialize unbound method functions, therefore these defaults are declared here.
"""


def introduction_default():
    return Mission.get_default_text('introduction.txt')


def executive_summary_default():
    return Mission.get_default_text('executive_summary.txt')


def scope_default():
    return Mission.get_default_text('scope.txt')


def objectives_default():
    return Mission.get_default_text('objectives.txt')


def technical_assessment_overview_default():
    return Mission.get_default_text('technical_assessment.txt')


def conclusion_default():
    return Mission.get_default_text('conclusion.txt')


"""
Models
"""


class Mission(models.Model):

    @staticmethod
    def get_default_text(file_name):
        TEMPALTE_DIR = os.path.join(settings.BASE_DIR, 'templates')
        with open(os.path.join(TEMPALTE_DIR, file_name), 'r') as template:
            output = join_as_compacted_paragraphs(template.readlines())
            return output

    # Model Fields

    mission_name = models.CharField(
        max_length=255,
        verbose_name="Mission Name",
    )

    mission_number = models.CharField(
        max_length=5,
        verbose_name="Mission Number",
    )

    test_case_identifier = models.CharField(
        max_length=20,
        blank=True,
        default="",
        verbose_name="Test Case Identifier",
    )

    business_area = models.ForeignKey(
        'BusinessArea',
        verbose_name="Business Area",
    )

    introduction = models.TextField(
        blank=True,
        verbose_name="Introduction",
        default=introduction_default,
    )

    executive_summary = models.TextField(
        blank=True,
        verbose_name="Executive Summary",
        default=executive_summary_default
    )

    scope = models.TextField(
        blank=True,
        verbose_name="Scope",
        default=scope_default
    )

    objectives = models.TextField(
        blank=True,
        verbose_name="Objectives",
        default=objectives_default
    )

    technical_assessment_overview = models.TextField(
        blank=True,
        verbose_name="Technical Assessment / Attack Architecture Overview",
        default=technical_assessment_overview_default
    )

    conclusion = models.TextField(
        blank=True,
        verbose_name="Conclusion",
        default=conclusion_default
    )

    # Mission-wide reporting include flags
    attack_phase_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Attack Phases in report?",
    )

    attack_type_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Attack Types in report?",
    )

    assumptions_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Assumptions in report?",
    )

    test_description_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Test Descriptions in report?",
    )

    findings_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Findings in report?",
    )

    mitigation_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Mitigations in report?",
    )

    tools_used_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Tools Used in report?",
    )

    command_syntax_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Command Syntaxes in report?",
    )

    targets_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Attack Targets in report?",
    )

    sources_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Attack Sources in report?",
    )

    attack_time_date_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Attack Times in report?",
    )

    attack_side_effects_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Attack Side Effects in report?",
    )

    test_result_observation_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Test Details in report?",
    )

    supporting_data_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include Supporting Data Information in report?"
    )

    customer_notes_include_flag = models.BooleanField(
        default=True,
        verbose_name="Mission Option: Include customer notes section in report?"
    )

    testdetail_sort_order = models.TextField(
        blank=True,
        default="[]"
    )

    def __str__(self):
        return "%s (%s)" % (self.mission_name, self.mission_number)


class Host(models.Model):
    mission = models.ForeignKey(
        Mission
    )

    host_name = models.CharField(
        blank=True,
        default="",
        max_length=100,
    )

    ip_address = models.GenericIPAddressField(
        blank=True,
        null=True,
    )

    is_no_hit = models.BooleanField(
        default=False,
    )

    @staticmethod
    def get_host_output_format_string():
        format_string = str(DARTDynamicSettings.objects.get_as_object().host_output_format)
        return format_string

    def __str__(self):
        format_string = cache.get('host_output_format_string')
        if format_string is None:
            cache.set('host_output_format_string', Host.get_host_output_format_string(), 300)
            format_string = cache.get('host_output_format_string')
        return format_string.format(name=self.host_name, ip=self.ip_address)

    def get_absolute_url(self):
        return


class TestDetail(models.Model):
    mission = models.ForeignKey(Mission, verbose_name="Mission")

    test_number = models.IntegerField(
        blank=False,
        verbose_name="Test Number",
        default=0
    )

    test_case_include_flag = models.BooleanField(
        default=True,
        verbose_name="Include Test Case in report?"
    )

    TEST_CASE_STATUSES = (
        ('NEW', 'Not started'),
        ('IN_WORK', 'In work'),
        ('REVIEW', 'Ready for review'),
        ('FINAL', 'Approved / Final'),
    )

    test_case_status = models.CharField(
        choices=TEST_CASE_STATUSES,
        max_length=100,
        verbose_name="Test Case Status",
        default='NEW',
    )

    enclave = models.CharField(
        blank=True,
        max_length=100,
        verbose_name='Enclave Test Executed From'
    )

    test_objective = models.CharField(
        blank=False,
        max_length=255,
        verbose_name="Test Objective / Title",
        help_text="Brief objective (ex.Port Scan against xyz)",
    )

    # Note: Attack Phases based on the Lockheed Martin Kill Chain(R)
    ATTACK_PHASES = (
        ('RECON', 'Reconnaissance'),
        ('WEP', 'Weaponization'),
        ('DEL', 'Delivery'),
        ('EXP', 'Exploitation'),
        ('INS', 'Installation'),
        ('C2', 'Command & Control'),
        ('AOO', 'Actions on Objectives'),
    )

    attack_phase = models.CharField(
        choices=ATTACK_PHASES,
        max_length=20,
        verbose_name="Attack Phase",
    )

    attack_phase_include_flag = models.BooleanField(
        default=True,
        verbose_name="Include Attack Phase in report?",
    )

    attack_type = models.CharField(
        blank=True,
        max_length=255,
        verbose_name="Attack Type",
        help_text="Example: SYN flood, UDP flood, malformed packets, web, fuzz, etc.",
    )

    attack_type_include_flag = models.BooleanField(
        default=True,
        verbose_name="Include Attack Type in report?",
    )

    assumptions = models.TextField(
        blank=True,
        verbose_name="Assumptions",
        help_text="Example: Attacker has a presence in xyz segment, etc."
    )

    assumptions_include_flag = models.BooleanField(
        default=True,
        verbose_name="Include Assumptions in report?",
    )

    test_description = models.TextField(
        blank=True,
        verbose_name="Description",
        help_text="Describe test case to be performed, what is the objective of this test case (Is it to deny, disrupt, penetrate, modify etc.)"
    )

    test_description_include_flag = models.BooleanField(
        default=True,
        verbose_name="Include Test Description in report?",
    )

    source_hosts = models.ManyToManyField(
        'Host',
        related_name='source_set',
    )

    sources_include_flag = models.BooleanField(
        default=True,
        verbose_name="Include Attack Sources in report?",
    )

    target_hosts = models.ManyToManyField(
        'Host',
        related_name='target_set',
    )

missions/templates/business_area_list.html
{% extends 'base.html' %}

{% comment %}
# Copyright 2017 Lockheed Martin Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
{% endcomment %}

{% load bootstrap3 %}
{% block title %}Business Area Update{% endblock %}

{% block extra_nav_bar_content_right %}
<li class="">
        <a href="{% url 'update-settings' %}">System Settings</a>
</li>
{% endblock %}

{% block main_heading %}
<h1 class="page-header">Business Area Update<div style="float:right"><a href="#" class="btn btn-primary" onclick="addNewBusinessAreaRow()">{% bootstrap_icon "plus" %} Add New</a></div></h1>
{% endblock %}
{% block content %}

<div class="clearfix">&nbsp;</div>
<table class="table table-hover table-bordered table-striped table-responsive" id="business-area-list">
    <tr>
        <th>Name</th>
        <th>Actions</th>
    </tr>

    {% for ba in object_list %}
        <tr>
            <td id="name-{{ba.id}}">{{ ba.name }}</td>
            <td>
                <a id="edit-business-area-{{ba.id}}" href="#" onclick="beginBusinessAreaUpdate('{{ba.id}}', '{% url 'update-business-area' pk=ba.id %}')">{% bootstrap_icon "pencil" %}</a>&nbsp;
                <a href="#" onclick="deleteBusinessArea('{% url 'update-business-area' pk=ba.id %}')">{% bootstrap_icon "trash" %}</a><br />
            </td>
        </tr>
    {% endfor %}
</table>

<script type="text/javascript">
    function deleteBusinessArea(url) {
        $.ajax({
                url: url,
                method: "DELETE",
                success: function(data, textStatus, jqXHR) {
                    if (!data.success) {
                        alert(data.message);
                    }
                    window.location.reload();
                }
             }
        );
    }

    function beginBusinessAreaUpdate(id, url) {
        var jqObj = $('#name-' + id);
        var text = jqObj.text();
        html_replacement = "<input id='business-area-name-" + id + "' class='ba-name-text-field' data-id=" + id + " data-url=" + url + "></input>"
        var ba_input = $("<input type='text'>")
            .attr("id", "business-area-name-" + id)
            .addClass("ba-name-text-field")
            .addClass("form-control")
            .data("id", id)
            .data("url", url)
            .val(text)
        jqObj.html(ba_input);
        jqObj.append("&nbsp;<em>Press enter to add</em>");
    }

    function updateBusinessArea(url, value) {
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify({
                name: value
                }),
            success: function (data, textStatus, jqXHR) {
                if (!data.success) {
                    alert(data.message);
                }
                else {
                    window.location.reload();
                }
            }
        });
    }

    function addNewBusinessAreaRow() {
        var jqTable = $("#business-area-list");
        jqTable.append("<tr><td><input class='ba-name-text-field' data-url='{% url 'update-business-area' %}'></input>&nbsp;<em>Press enter to save</em></td><td>&nbsp;</td></tr>");
    }

    function newBusinessArea(url) {
        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify({
                name: value
                }),
            success: function (data, textStatus, jqXHR) {
                if (!data.success) {
                    alert(data.message);
                }
                else {
                    window.location.reload();
                }
            }
        });
    }
$(function() {
    $("#business-area-list").on("keyup", ".ba-name-text-field", function(event) {
        /* On enter, update the business area */
        if (event.keyCode == 13) {
            updateBusinessArea($(this).data("url"), $(this).val());
        }
    });
});
</script>

{% endblock %}

missions/templates/color_list.html
{% extends 'base.html' %}

{% comment %}
# Copyright 2017 Lockheed Martin Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
{% endcomment %}

{% load bootstrap3 %}
{% block title %}Color Options Update{% endblock %}

{% block extra_nav_bar_content_right %}
<li class="">
        <a href="{% url 'update-settings' %}">System Settings</a>
</li>
{% endblock %}

{% block main_heading %}
<h1 class="page-header">Color Options Update<div style="float:right"><button class="btn btn-primary" onclick="addNewColorRow()">{% bootstrap_icon "plus" %} Add New</button></div></h1>
{% endblock %}
{% block content %}

<div class="clearfix">&nbsp;</div>
<table class="table table-hover table-bordered table-striped table-responsive" id="color-options-list">
    <tr>
        <th>Display Text</th>
        <th>6-Character Hex Code (RGB)</th>
        <th>Actions</th>
    </tr>

    {% for color in object_list %}
        <tr id="row-id-{{color.id}}" data-url="{% url 'update-color' pk=color.id %}">
            <td>
                <span class="cell-content">{{ color.display_text }}</span>
                <input type="text" class="hide form-control" data-key="display_text" value="{{ color.display_text }}" />
            </td>
            <td>
                <span class="cell-content">{{ color.hex_color_code }}</span>
                <input type="text" class="hide form-control" data-key="hex_color_code" value="{{ color.hex_color_code }}" />
            </td>
            <td>
                <span id="edit-color-{{color.id}}" onclick="beginColorUpdate('{{color.id}}', '{% url 'update-color' pk=color.id %}')">{% bootstrap_icon "pencil" %}</span>&nbsp;
                <span onclick="deleteColor('{% url 'update-color' pk=color.id %}')">{% bootstrap_icon "trash" %}</span><br />
            </td>
        </tr>
    {% endfor %}
</table>

<script type="text/javascript">
    function deleteColor(url) {
        $.ajax({
                url: url,
                method: "DELETE",
                success: function(data, textStatus, jqXHR) {
                    if (!data.success) {
                        alert(data.message);
                    }
                    window.location.reload();
                }
             }
        );
    }

    function beginColorUpdate(id, url) {
        var jqObj = $('#row-id-' + id)
        jqObj.find(".form-control, .cell-content").toggleClass("hide");
    }

    function updateColor($row) {
        var url = $row.data("url");

        var values = {};

        values.display_text = $row.find("input[data-key='display_text']").first().val();
        values.hex_color_code = $row.find("input[data-key='hex_color_code']").first().val();

        $.ajax({
            url: url,
            method: "POST",
            data: JSON.stringify(values),
            success: function (data, textStatus, jqXHR) {
                if (!data.success) {
                    alert(data.message);
                }
                else {
                    window.location.reload();
                }
            }
        });
    }

    function addNewColorRow() {
        var jqTable = $("#color-options-list");

        var row = $("<tr/>")
            .attr("id", "row-id-0")
            .attr("data-url", "{% url 'update-color' %}");

        var display_text_col = $("<td></td>");
        var display_text_input = $("<input type='text'>")
            .addClass("form-control")
            .attr("data-key", "display_text");
        display_text_col.append(display_text_input);

        var hex_color_code_col = $("<td></td>");
        var hex_color_code_input = $("<input type='text'>")
            .addClass("form-control")
            .attr("data-key", "hex_color_code");
        hex_color_code_col.append(hex_color_code_input);

        jqTable.append(row);
        row.append(display_text_col);
        row.append(hex_color_code_col);
    }

$(function() {
    $("#color-options-list").on("keyup", ".form-control", function(event) {
        /* On enter, update the color */
        if (event.keyCode == 13) {
            updateColor($(this).closest("tr"));
        }
    });
});
</script>

{% endblock %}

missions/templates/delete_mission.html
{% extends 'base.html' %}

{% comment %}
# Copyright 2017 Lockheed Martin Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
{% endcomment %}

{% load bootstrap3 %}
{% block title %}
     Confirm Mission Deletion
{% endblock %}

{% block main_heading %}
<h1 class="page-header">
    Confirm Mission Deletion
</h1>
{% endblock %}

{% block content %}
<p>Are you sure you want to permanently delete this mission and all the hard work you put into it?</p>
<form method="POST">
{% csrf_token %}

{% buttons %}
    <a class="btn btn-primary" href="{% url 'missions-edit' mission.id%}">I've made a horrible mistake! Take me back!</a>
    <button type="submit" class="btn btn-danger pull-right">
        {% bootstrap_icon "trash" %} Delete Forever
    </button>
{% endbuttons %}
</form>
{% endblock %}

missions/templates/edit_mission_hosts.html
{% extends 'base.html' %}

{% comment %}
# Copyright 2017 Lockheed Martin Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
{% endcomment %}

{% load bootstrap3 %}

{% block title %}
Edit Mission Hosts
{% endblock %}

{% block main_heading %}
<h1 class="page-header">
Edit Mission Hosts
</h1>
{% endblock %}

{% block content %}
<div class="clearfix">&nbsp;</div>

{% include 'modals/edit_missionhosts_modal.html' with mission_id=mission.pk%}

{% csrf_token %}
<div class="row">
    <div class="col-lg-12">
        <table class="table table-hover table-bordered table-striped table-responsive">
            <tr>
                <th>Name</th>
                <th>IP Address</th>
                <th style="width: 5%">No-Hit</th>
                <th style="width: 7%;">Actions</th>
            </tr>
            {% for host in mission.host_set.all %}
            <tr data-host_pk="{{ host.pk }}">
                <td>{{ host.host_name }}</td>
                <td>{{ host.ip_address }}</td>
                <td style="text-align: center;">
                    {% if host.is_no_hit %}
                    Yes
                    {% else %}
                    No
                    {% endif %}

                </td>
                <td style="text-align: center;">
                    <a href="#editMissionHostsModal" onclick="" class="MHModalToggle" data-tgt="{{ host.pk }}" data-toggle="modal">{% bootstrap_icon "pencil" %}</a>
                    &nbsp;&nbsp;&nbsp;
                    <a href="#" onclick="removeMissionHost({{host.pk}});">{% bootstrap_icon "trash" %}</a>
                </td>
            </tr>
            {% endfor %}
        </table>
    </div>
</div>
<div class="row">
    <div class="col-lg-12">
        <div class="pull-right"><button class="btn btn-primary MHModalToggle" data-tgt="new" data-toggle="modal" data-target="#editMissionHostsModal">{% bootstrap_icon "plus" %} Add New</button></div>
    </div>
</div>

<script type="text/javascript">

    // editButtonClick

    // deleteButtonClick


    // newHostButtonClick

    // updateRowData

    // addRow

    // hostAjaxErrorHandler


</script>

{% endblock %}